clear
randnum = 20;
methods = {'LRBFGS', 'LRTRSR1', 'RSD'}; % {'LRBFGS'}; % {'WFlow'}; % {'LRBFGS', 'LRTRSR1'}; % 
n1s = [32, 64, 64, 128, 128, 256, 256, 512, 512];
n2s = [32, 32, 64, 64,  128, 128, 256, 256, 512];
% n1s = 32; %[32, 64, 128, 256, 512, 1024];
% n2s = 32; %[32, 64, 128, 256, 512, 1024];

prob = 1;
tab = zeros(21, 9, randnum);
for i = 1 : randnum
    seed = i;
    for j = 1 : length(methods)
        for k = 1 : length(n1s)
            [i, j, k]
            [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, eigHess, relerr] = Testproblem(seed, methods{j}, prob, n1s(k), n2s(k));
            tab(1 + j * 7 - 7, k, i) = iter;
            tab(2 + j * 7 - 7, k, i) = nf;
            tab(3 + j * 7 - 7, k, i) = ng;
            tab(4 + j * 7 - 7, k, i) = gfgf0;
            tab(5 + j * 7 - 7, k, i) = f;
            tab(6 + j * 7 - 7, k, i) = ComTime;
            tab(7 + j * 7 - 7, k, i) = relerr;
        end
    end
end

TimeTab(:, 1) = reshape(tab(6, :, :), [], 1);
TimeTab(:, 2) = reshape(tab(13, :, :), [], 1);
TimeTab(:, 3) = reshape(tab(20, :, :), [], 1);

minTime = min(TimeTab')';
minTime = repmat(minTime, 1, 3);
perfratio = TimeTab ./ minTime;

taumax = max(perfratio(:));

figure(1);clf
set(0,'defaultaxesfontsize',15, ...
   'defaultaxeslinewidth',0.7, ...
   'defaultlinelinewidth',.8,'defaultpatchlinewidth',0.8);
set(0,'defaultlinemarkersize',10)
shapes = {'-b', '--k', '-.m', ':r', 'm', 'y'};
for i = 1 : 3
    v = sort(perfratio(:, i));
    xy = [v, ((1:length(v)) / length(v))'];
    xy = [1, 0; xy; taumax, 1];
    xynew = zeros(2 * size(xy, 1) - 1, 2);
    xynew(1:2:end, :) = xy;
    for j = 2 : 2 : size(xynew, 1)
        xynew(j, 1) = xynew(j + 1, 1);
        xynew(j, 2) = xynew(j - 1, 2);
    end

    plot(xynew(:, 1), xynew(:, 2), [shapes{i}]); hold on;
end
legend('LRBFGS', 'LRTRSR1-R', 'RBB');
xlabel('\tau')
ylabel('\rho_s(\tau)');
title('Performance profile on blind deconvolution');
savefig('CFROBlindDecon2DLRBFGSvsLRTRSR1_fig');

avetab = mean(tab, 3);

fout = fopen('CFROBlindDecon2DLRBFGSvsLRTRSR1.txt','w');
for i = 1 : size(avetab, 1)
    for j = 1 : size(avetab, 2)
        if(mod(i, 7) == 1 || mod(i, 7) == 2 || mod(i, 7) == 3)
            fprintf(fout, '%d', round(avetab(i, j)));
        elseif(mod(i, 7) == 4 || mod(i, 7) == 5 || mod(i, 7) == 6 || mod(i, 7) == 0)
            fprintf(fout, '$%s$ ', outputfloat(avetab(i, j)));
        end
        if(j < size(avetab, 2))
            fprintf(fout, ' & ', avetab(i, j));
        end
    end
    fprintf(fout,'\\\\\n');
end
fclose(fout);

function [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, eigHess, relerr] = Testproblem(seed, method, prob, n1, n2)
    rng(seed);
    if(prob == 1)
        fprintf('MTestCFRankQ2FBlindDecon2D seed:%d\n', seed);
        
        load('flower.mat')
%         testimage = testimage((1:256) + 256, (1:256)+256);
%         Itrue = double(testimage(1:end, 1:end))/255;
%         n1 = size(Itrue,1);
%         n2 = size(Itrue,2);
%         Itrue = randn(n1, n2);
        grayflower = rgb2gray(flower);
        
        startxidx = randi(size(flower, 1) - n1 + 1);
        startyidx = randi(size(flower, 2) - n2 + 1);
        
        Itrue = double(grayflower(startxidx : startxidx + n1 - 1, startyidx : startyidx + n2 - 1))/255;
%         Itrue = rand(n1, n2);%%----
        Itrue = Itrue / norm(Itrue, 'fro');

        L = n1 * n2;
        r = 1;
        %% blur kernel and corresponding mask matrix B
        kernel = fspecial('motion',round(n1 / 20),45);
%         kernel = kernel / norm(kernel, 'fro');
        [k1,k2] = size(kernel);
        htrue = zeros(n1,n2);
        htrue((n1)/2-(k1+1)/2+2:(n1)/2+(k1+1)/2,(n2+1)/2-(k2+1)/2+2:(n2+1)/2+(k2+1)/2)=kernel;

        %     %% Gaussian kernel
        %     sigma = [1, 0.5; 0.5, 2];
        %     kernel = gaussiankernal(sigma, 11, 11);
        %     kernel(find(kernel < 1e-3)) = 0;
        %     [k1,k2] = size(kernel);
        %     htrue = zeros(n1,n2);
        %     htrue(ceil((n1-k1)/2) + 1:ceil((n1-k1)/2) + k1, ceil((n2 - k2)/2) + 1:ceil((n2 - k2)/2) + k2)=kernel;
        %     sum(sum(kernel > 0))
        %     return;

        htrue = fftshift(htrue);
        maskB = zeros(n1,n2); % support of kernel
        maskB(abs(htrue)>0)=1;
        B = spdiags(complex(maskB(:), eps * ones(L, 1)), 0, L, L);

        %% Wavelet and corresponding mask matrix C
        Iblur = ifft2(fft2(Itrue).*fft2(htrue)); % same as Iblur = imfilter(Itrue,kernel,'circular');
        [WIblur] = haarFWT_2d(Iblur);
        %     [WIblur] = haarFWT_2d(Itrue);

        dimW = round(L / 100); % 5000;% 
        [~,ind] = sort(abs(WIblur(:)),'descend');%%%%%% should be mriconW
        maskW = zeros(size(WIblur)); %%%%%%%
        maskW(ind(1:dimW)) = 1;
        C = spdiags(complex(maskW(:), eps * ones(L, 1)), 0, L, L);

        %% True solution
        [WItrue] = haarFWT_2d(Itrue);
        truesoln = zeros(4 * L * r, 1);
        truesoln(1:2:end) = [htrue(:); WItrue(:)];

        %% Initial iterate
        n = sqrt(n1*n2);
        AA = @(x) 1/n*fft2(haarFWT_2d_inverse(maskW.*reshape(x,n1,n2)));
        AAt = @(Ax) maskW.*(haarFWT_2d(n*ifft2(Ax)));
        BB = @(h) 1/n*fft2(maskB.*h);
        BBt = @(Bh) maskB.*(n*ifft2(Bh));
        y = fft2(Iblur);
        %     y = complex(full(y), eps * ones(size(y)));
        start = spectral_init(y/L,AA,AAt,BB,BBt,L);
        hinit = start.u * sqrt(start.s);
        minit = start.v * sqrt(start.s);
        xinit = complex([hinit(:); minit(:)]);
        % xinit = complex(truesoln(1:2:end), truesoln(2:2:end));%%---

        SolverParams.method = method;
        SolverParams.IsCheckParams = 1;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 100;
%         SolverParams.LengthSY = 2;
        SolverParams.Verbose = 2;
        SolverParams.Tolerance = 1e-5;
%         SolverParams.LineSearch_LS = 1;
%         SolverParams.IsCheckGradHess = 1;
%         SolverParams.isconvex = 1;
        %     SolverParams.LS_ratio1 = 0.1;
        %     SolverParams.LS_ratio2 = 0.9;
        %     SolverParams.Num_pre_BB = 0;
        %     SolverParams.BBratio = 1;
        %     SolverParams.Tolerance = 1e-7;
        HasHHR = 0;
        rho = start.s^2/100;
        mu = (6/log(L))*sqrt(L/(dimW + sum(sum(kernel ~= 0))));%(1000/log(L))*sqrt(L/(dimW+sum(sum(htrue))));
        d = 50*norm(WIblur,'fro');
        ParamSet = 2;
        [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, eigHess] = TestCFRankQ2FBlindDecon2D(y(:), B, C, xinit, n1, n2, r, HasHHR, rho, d, mu, ParamSet, SolverParams);

%         soln = Xopt.main;
        soln = complex(Xopt.main(1:2:end), Xopt.main(2:2:end));
        WIfinal = reshape(soln(L + 1 : end), n1, n2);
        Ifinal = haarFWT_2d_inverse(maskW.*WIfinal);
        RealIfinal = (Ifinal .* conj(Ifinal)).^0.5;
        relerr = norm(Itrue - RealIfinal / norm(RealIfinal, 'fro') * norm(Iblur, 'fro'), 'fro') / norm(Itrue, 'fro')
        fprintf('Final relres:%f, nBh/nCm:%d, nFFT:%d, relerr:%f\n', f.^0.5/norm(y), nf + ng, 2 * nf + 3 * ng, norm(Itrue - RealIfinal / norm(RealIfinal, 'fro') * norm(Iblur, 'fro'), 'fro') / norm(Itrue, 'fro'));
    end
end

function str = outputfloat(x)
    if(x <= 0)
        sn = '-';
        x = abs(x);
    else
        sn = '';
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [sn strx '_{' num2str(p) '}'];
    else
        str = [sn strx];
    end
end

function output = Ax(U, masks, b, kappa)
    x.U = U;
    [n1, n2, l] = size(masks);
    n = n1 * n2;
    m = l * n;
    k = size(x.U, 2);
    ZY = zeros(m, k);
    for i = 1 : l
        for j = 1 : k
            temp = fft2(reshape(x.U(:, j), n1, n2) .* masks(:, :, i)) / sqrt(n1 * n2);
            ZY((i - 1) * n + 1 : i * n, j) = reshape(temp, [], 1);
        end
    end
    DZY = zeros(m, k);
    for i = 1 : k
        DZY(:, i) = b .* ZY(:, i);
    end
    %% Z^H *DZY
    Y = zeros(n, k);
    for i = 1 : l
        temp = zeros(n, k);
        for j = 1 : k
            temp(:, j) = reshape(ifft2(reshape(DZY((i - 1) * n + 1 : i * n, j) * sqrt(n1 * n2), n1, n2)), [], 1);
            temp(:, j) = conj(reshape(masks(:, :, i), [], 1)) .* temp(:, j);
        end
        Y = Y + temp;
    end
    output = Y;
end
% 
% function output = Afun(x, tflag, A)
%     if strcmp(tflag,'notransp')
%         output = A * x;
%     else
%         output = A' * x;
%     end
% end
% 
% function output = computeAH(As, Type)
% 
%     k = length(As);
%     
%     for i = 1:k
%         invAs{i} = pinv(As{i});
%     end
%     
%     Ar = As{1};
%     for i = 2:k
%        Ar = Ar + As{i};
%     end
%     Ar = Ar/k;
%     
%     if (Type == 0)
%         output = Ar;
%     end
%     
%     
%     if(Type == 1)
%     Ha = pinv(As{1});
%     for i = 2:k
%         Ha = Ha + invAs{i};
%     end
%     
%     Ha = pinv(Ha/k);
%     Arh = Ar^(0.5);
%     Arinvh = Ar^(-0.5);
%     temp = Arinvh * Ha * Arinvh;
%     output = Arh * temp^(0.5) * Arh;
%     end
% end

function start = spectral_init(yo,A,At,B,Bt,L)
    v = randn(1,L);
    niter = 50;
    for i = 1 : niter
        u = Bt(yo.*conj(A(conj(v)))); 
        s = norm(u,'fro');
        u = u/s;

        v = conj(At(conj(B(u)).*yo));
        s = norm(v,'fro');
        v = v/s;
        
%         u = Bt(yo.*(A((v)))); 
%         s = norm(u,'fro');
%         u = u/s;
%         v = (At((B(u)).*conj(yo)));
%         s = norm(v,'fro');
%         v = v/s;
    end
    start.u = u;
    start.s = s;
    start.v = conj(v);
end

function M = haarFWT_2d(M)
    [n1, n2] = size(M);
    tmp = M;
    r2 = sqrt(2);
    k = 1;
    while(2 * k <= n1)
        k = k * 2;
    end
    while(1 < k)
        k = k / 2;
        for j = 1 : n2
            for i = 1 : k
                tmp(i, j) = (M(2 * i - 1, j) + M(2 * i, j)) / r2;
                tmp(k + i, j) = (M(2 * i - 1, j) - M(2 * i, j)) / r2;
            end
        end
        for j = 1 : n2
            for i = 1 : 2 * k
                M(i, j) = tmp(i, j);
            end
        end
    end
    k = 1;
    while(2 * k <= n2)
         k = k * 2;
    end
    while(1 < k)
        k = k / 2;
        for j = 1 : k
            for i = 1 : n1
                tmp(i, j) = (M(i, 2 * j - 1) + M(i, 2 * j)) / r2;
                tmp(i, k + j) = (M(i, 2 * j - 1) - M(i, 2 * j)) / r2;
            end
        end
        for j = 1 : 2 * k
            for i = 1 : n1
                M(i, j) = tmp(i, j);
            end
        end
    end
end

function M = haarFWT_2d_inverse(M)
    [n1, n2] = size(M);
    tmp = M;
    r2 = sqrt(2);
    k = 1;
    while(k * 2 <= n2)
        for j = 1 : k
            for i = 1 : n1
                tmp(i, 2 * j - 1) = (M(i, j) + M(i, k + j)) / r2;
                tmp(i, 2 * j) = (M(i, j) - M(i, k + j)) / r2;
            end
        end
        for j = 1 : 2 * k
            for i = 1 : n1
                M(i, j) = tmp(i, j);
            end
        end
        k = k * 2;
    end
    k = 1;
    while(k * 2 <= n1)
        for j = 1 : n2
            for i = 1 : k
                tmp(2 * i - 1, j) = (M(i, j) + M(k + i, j)) / r2;
                tmp(2 * i, j) = (M(i, j) - M(k + i, j)) / r2;
            end
        end
        for j = 1 : n2
            for i = 1 : 2 * k
                M(i, j) = tmp(i, j);
            end
        end
        k = k * 2;
    end
end

function kernel = gaussiankernal(sigma, xs, ys)
    x = linspace(-2, 2, xs);
    y = linspace(-2, 2, ys);
    [X, Y] = meshgrid(x, y);
    sigma = sigma / det(sigma);
    invsigma = pinv(sigma);
    kernel = exp(-0.5 * (X .* X * invsigma(1, 1) + X .* Y * invsigma(1, 2) + Y .* X * invsigma(2, 1) + Y .* Y * invsigma(2, 2))) / 2 / pi;
    kernel = kernel / sum(sum(kernel));
end
