
randnum = 20;

% methods = {'LRTRSR1woR'}; %{'LRBFGS', 'LRBFGS', 'LRBFGS', 'LRBFGS', 'LRTRSR1woR', 'LRTRSR1woR', 'LRTRSR1', 'LRTRSR1'};
% LMrestarts = 0;% [0, 0, 1, 1, 0, 0, 1, 1];
% % LengthSYs = [1, 4, 1, 4, 1, 4, 1, 4];
% LengthSYs = 4; %[0, 4, 0, 4, 0, 4, 0, 4];

methods = {'LRBFGS', 'LRBFGS', 'LRBFGS', 'LRBFGS', 'LRTRSR1woR', 'LRTRSR1woR', 'LRTRSR1', 'LRTRSR1'};
LMrestarts = [0, 0, 1, 1, 0, 0, 1, 1];
LengthSYs = [2, 4, 2, 4, 2, 4, 2, 4];
% LengthSYs = [0, 4, 0, 4, 0, 4, 0, 4];

prob = 1;
tab = zeros(6, 8, randnum);
for i = 1 : randnum
    seed = i;
    for j = 1 : length(methods)
        [i, j]
        [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, fail] = Testproblem(seed, methods{j}, LMrestarts(j), LengthSYs(j), prob);
        tab(1, j, i) = iter;
        tab(2, j, i) = nf;
        tab(3, j, i) = ng;
        tab(4, j, i) = gfgf0;
        tab(5, j, i) = f;
        tab(6, j, i) = ComTime;
    end
end

avetab = mean(tab, 3);

fout = fopen('EucQuaLRBFGSvsLRTRSR1.txt','w');
for i = 1 : size(avetab, 1)
    for j = 1 : size(avetab, 2)
        if(i >= 1 && i <= 3)
            fprintf(fout, '%d ', round(avetab(i, j)));
        elseif(i >= 4 && i <= 6)
            fprintf(fout, '$%s$ ', outputfloat(avetab(i, j)));
        end
        if(j < size(avetab, 2))
            fprintf(fout, ' & ', avetab(i, j));
        end
    end
    fprintf(fout,'\\\\\n');
end
fclose(fout);

function [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times, fail] = Testproblem(seed, method, LMrestart, LengthSY, prob)
    rng(seed);
    fail = 0;
    if(prob == 1)
        fprintf('MTestEucQuadratic seed:%d\n', seed);
        
%         % dataset 1
%         dim = 200;
%         O = orth(randn(dim, dim));
%         D = diag(logspace(-2, 1, dim) .* (rand(1, dim) + 0.5));
%         M = O' * D * O;
        
% %         % dataset 2
%         dim = 200;
%         M = randn(dim, dim); M = M' * M;
        
        % dataset 3
        dim = 200;
        diffnum = 4;
        O = orth(randn(dim, dim));
%         a = logspace(-1, 1, diffnum) .* (rand(1, diffnum) + 0.5);
        a = linspace(0.1, 10, diffnum) .* (rand(1, diffnum) + 0.5);
        D = repmat(a, dim/diffnum, 1); D = D(:);
        D = diag(D);
        M = O' * D * O;
        
%         % dataset 4
%         dim = 1000;
%         O = orth(randn(dim, 4));
%         D = diag(1:4);
%         M = O * D * O';

        Xinitial = randn(dim, 1);
        SolverParams.method = method;
        SolverParams.IsCheckParams = 1;
        SolverParams.Max_Iteration = 5000;
        SolverParams.OutputGap = 1000;
        SolverParams.LengthSY = LengthSY;
        SolverParams.LMrestart = LMrestart;
%         SolverParams.InitSteptype = 0;
%         SolverParams.Lgamma = 1e16;
%         SolverParams.initial_Delta = 64;
        SolverParams.verbose = 1;
        HasHHR = 0;
        [Xopt, f, gf, gfgf0, iter, nf, ng, nR, nV, nVp, nH, ComTime, funs, grads, times] = TestEucQuadratic(M, Xinitial, HasHHR, SolverParams);
    end
end

function str = outputfloat(x)
    if(x <= 0)
        sn = '-';
        x = abs(x);
    else
        sn = '';
    end
    p = log(x)/log(10);
    p = - ceil(-p);
    x = round(x * 10^(-p) * 100);
    x = x / 100;
    strx = sprintf('%3.2f', x);
    if(p ~= 0)
        str = [sn strx '_{' num2str(p) '}'];
    else
        str = [sn strx];
    end
end

function output = Afun(x, tflag, A)
    if strcmp(tflag,'notransp')
        output = A * x;
    else
        output = A' * x;
    end
end

function output = computeAH(As, Type)

    k = length(As);
    
    for i = 1:k
        invAs{i} = pinv(As{i});
    end
    
    Ar = As{1};
    for i = 2:k
       Ar = Ar + As{i};
    end
    Ar = Ar/k;
    
    if (Type == 0)
        output = Ar;
    end
    
    
    if(Type == 1)
    Ha = pinv(As{1});
    for i = 2:k
        Ha = Ha + invAs{i};
    end
    
    Ha = pinv(Ha/k);
    Arh = Ar^(0.5);
    Arinvh = Ar^(-0.5);
    temp = Arinvh * Ha * Arinvh;
    output = Arh * temp^(0.5) * Arh;
    end
end
